#include "libxml_meson.h"

#include <libxml/xmlversion.h>
#include <libxml/parser.h>
#include <libxml/tree.h>
#include <iostream>

void info_libxml(void)
{
    std::cout << "[LIBXML2]\tversion: " << LIBXML_DOTTED_VERSION << std::endl;
}

void create_xml(void)
{
    std::cout << "[LIBXML2]\tWriting basic .xml file..." << std::endl;
    // Create new doc
    xmlDocPtr doc = xmlNewDoc(BAD_CAST "1.0");
    xmlNodePtr root_node = xmlNewNode(nullptr, BAD_CAST "root");
    xmlDocSetRootElement(doc, root_node);

    xmlNodePtr child1 = xmlNewChild(root_node, nullptr, BAD_CAST "child1", BAD_CAST "This is child 1");
    xmlNewProp(child1, BAD_CAST "attribute", BAD_CAST "value");

    // Save the document
    const char* filename = "example.xml";
    if (xmlSaveFormatFileEnc(filename, doc, "UTF-8", 1) != -1) {
        std::cout << "[LIBXML2]\tXML file created successfully: " << filename << std::endl;
    } else {
        std::cerr << "LIBXML2]\tError saving XML file!" << std::endl;
    }

    // Clean up
    xmlFreeDoc(doc);
    xmlCleanupParser();
}